<script setup>
import useVuelidate from "@vuelidate/core";
import {
  required,
  email,
  minLength,
  sameAs,
  alphaNum,
} from "@vuelidate/validators";
import { validPassword } from "@/validators";
import { reactive, computed, ref, onMounted } from "vue";
import { useRouter } from "vue-router";
import { mdiAccount, mdiAsterisk } from "@mdi/js";
import FullScreenSection from "@/components/FullScreenSection.vue";
import SectionComponent from "@/components/SectionComponent.vue";
import CheckRadioPicker from "@/components/CheckRadioPicker.vue";
import Field from "@/components/Field.vue";
import Control from "@/components/Control.vue";
import Divider from "@/components/Divider.vue";
import JbButton from "@/components/JbButton.vue";
import JbButtons from "@/components/JbButtons.vue";
import AuthService from "@/api/authService";
import { useToast } from "vue-toastification";
import Account from "@/api/account";
import VOtpInput from "vue3-otp-input";
const toast = useToast();
const router = useRouter();
var profileList = reactive({ value: [] });
const otpInput = ref(null);
const otp = ref();
onMounted(() => {
  Account.get().then((data) => {
    profileList.value = data?.data;
    console.log("profileList", profileList.value);
    console.log("profileitems", profileitems);
  });
});
// Profile List Store
const profileitems = computed(() => {
  return profileList.value;
});
const handleOnComplete = (value) => {
  console.log("OTP completed: ", value);
  user.otp=value;

};

const handleOnChange = (value) => {
  console.log("OTP changed: ", value);
};
const clearInput = () => {
  otpInput.value.clearInput();
};
 const otpNumber=()=> {
      return otpOne + otpTwo + otpThree + otpFour
    }

const user = reactive({
  email: "",
  otp: "",
  password: "",
});
const rules = computed(() => {
  return {
    email: { required, email },

    password: { required, minLength: minLength(8),
      validators: {
        $validator: validPassword,
        $message:
          "The password requires an uppercase, lowercase, number and special character",
      },  },
    confirm: { required, sameAs: sameAs(user.password) },
  };
});
const v$ = useVuelidate(rules, user);
// Reset Password Function calling
const resetPassword = () => {

  console.log("user", user);
  // vuelidate validation
  v$.value.$validate();
  // if success
  if (!v$.value.$error) {
    AuthService.resetPass(user)
      .then((data) => {
        console.log("data", data?.success);
        if (data?.success) {
          toast.success(data?.message);
          router.push("/");
        } else {
          toast.error(data?.message);
        }
      })
      .catch((error) => {
        let message =
          error?.data?.message ||
          "Invalid or expired OTP. Please request another to proceed further";
        toast.error(message);
      });
  }
};
const hidePassword = ref(true);
const passwordFieldType = computed(() =>
  hidePassword.value ? "password" : "text"
);
//
const hidePassword1 = ref(true);
const passwordFieldType1 = computed(() =>
  hidePassword1.value ? "password" : "text"
);
</script>

<template>
  <full-screen-section
    v-slot="{ cardClass, cardRounded }"
    bg="login"
    class="h-full py-6 px-4"
  >
    <div class="row w-full justify-between my-1 mb-4 px-32 py-10 h-full">
      <router-link to="/">
        <img src="@/assets/icons/logo.svg" />
      </router-link>
    </div>

    <div class="flex justify-center justify-items-center">
      <div
        class="bg-white md:inline-flex md:px-14 px-4 py-20 w-4/5 rounded-lg shadow-pink-150 dropShadow-outer-lg"
      >
        <span class="md:w-1/2 w-full md:px-10 px-2">
          <h5 class="text-center text-pink-250 font-normal text-3xl mb-4">
            "Labour Care Guide"
          </h5>
          <center class="py-10">
            <img
              src="@/assets/icons/login-icon.svg"
              style="width: 300px"
              alt="logo"
            />
          </center>
        </span>
        <section-component
          :class="cardClass"
          :rounded="cardRounded"
          class="md:w-1/2 w-full md:px-10 px-0 shadow-none"
        >
          <h5
            class="text-center text-black-250 font-semibold text-xl mb-4 pb-4"
          >
            Reset Password
          </h5>
          <field label="Enter Email ID">
            <div class="flex-wrap">
              <control
                v-model="user.email"
                type="email"
                name="email"
                placeholder="Enter Email ID"
              />
              <span class="text-pink-250" v-if="v$.email.$error">
                {{ v$.email.$errors[0].$message }}
              </span>
            </div>
          </field>
          <field label="Enter OTP">
            <div class="flex">
              <v-otp-input
                ref="otpInput"
                input-classes="otp-input"
                separator="-"
                :num-inputs="4"
                :input-type="number"
                :should-auto-focus="true"
                :is-input-num="true"
                :conditionalClass="['one', 'two', 'three', 'four']"
                :placeholder="['*', '*', '*', '*']"
                @on-change="handleOnChange"
                @on-complete="handleOnComplete"
              />
              <button class="bg-gray-200 px-2 py-1" @click="clearInput()">
                Clear
              </button>
              <!-- <control v-model="user.otp" name="otp" type="text" placeholder="0" /> -->
              <!-- <span class="text-pink-250" v-if="v$.otp.$error">
                {{ v$.otp.$errors[0].$message }}
              </span> -->
            </div>
          </field>
          <field label="Enter New Password">
            <div class="flex-wrap">
              <control
                v-model="user.password"
                :type="passwordFieldType"
                name="password"
                placeholder="Enter New Password"
              />
              <img
                class="absolute -mt-6 right-72 cursor-pointer"
                src="@/assets/icons/eyes.svg"
                @click="hidePassword = !hidePassword"
              />
              <span class="text-pink-250" v-if="v$.password.$error">
                {{ v$.password.$errors[0].$message }}
              </span>
            </div>
          </field>
          <field label="Enter Confirm Password">
            <div class="flex-wrap">
              <control
                v-model="user.confirm"
                :type="passwordFieldType1"
                name="confirm-password"
                placeholder="Enter Confirm Password"
              />
              <img
                class="absolute -mt-6 right-72 cursor-pointer"
                src="@/assets/icons/eyes.svg"
                @click="hidePassword1 = !hidePassword1"
              />
              <span class="text-pink-250" v-if="v$.confirm.$error">
                {{ v$.confirm.$errors[0].$message }}
              </span>
            </div>
          </field>

          <jb-button
            color=""
            @click="resetPassword"
            label="Submit"
            class="mt-2 bg-pink-250 text-white w-full font-normal py-3 rounded-lg"
          />
        </section-component>
      </div>
    </div>
  </full-screen-section>
</template>
<style>
.otp-input {
  width: 40px;
  height: 40px;
  padding: 5px;
  margin: 0 10px;
  font-size: 20px;
  border-radius: 4px;
  border: 1px solid #fc5285;
  text-align: center;
}
/* Background colour of an input field with value */
.otp-input.is-complete {
  background-color: #e4e4e4;
}
.otp-input::-webkit-inner-spin-button,
.otp-input::-webkit-outer-spin-button {
  -webkit-appearance: none;
  margin: 0;
}
</style>
